#include "graphic.h"	

const unsigned char color = 1;

void GLCD_Rectangle(unsigned char x, unsigned char y, unsigned char b, unsigned char a)
{
  unsigned char j; 						// Hilfsvariable
  // zeichne vertikalen Linien (Seiten)
  for (j = 0; j < a; j++) {
		GLCD_SetPixel(x, y + j, color);
		GLCD_SetPixel(x + b - 1, y + j, color);
	}
  // zeichne horizontale Linie (Basis)
  for (j = 0; j < b; j++)	{
		GLCD_SetPixel(x + j, y, color);
		GLCD_SetPixel(x + j, y + a - 1, color);
	}
}
//

void GLCD_Circle(unsigned char cx, unsigned char cy ,unsigned char radius)
{
int x, y, xchange, ychange, radiusError;
x = radius;
y = 0;
xchange = 1 - 2 * radius;
ychange = 1;
radiusError = 0;
while(x >= y)
  {
  GLCD_SetPixel(cx+x, cy+y, color); 
  GLCD_SetPixel(cx-x, cy+y, color); 
  GLCD_SetPixel(cx-x, cy-y, color);
  GLCD_SetPixel(cx+x, cy-y, color); 
  GLCD_SetPixel(cx+y, cy+x, color); 
  GLCD_SetPixel(cx-y, cy+x, color); 
  GLCD_SetPixel(cx-y, cy-x, color); 
  GLCD_SetPixel(cx+y, cy-x, color); 
  y++;
  radiusError += ychange;
  ychange += 2;
  if ( 2*radiusError + xchange > 0 )
    {
    x--;
	radiusError += xchange;
	xchange += 2;
	}
  }
}
//

void GLCD_Line(unsigned int X1,unsigned int Y1,unsigned int X2,unsigned int Y2)
{
int CurrentX, CurrentY, Xinc, Yinc, 
    Dx, Dy, TwoDx, TwoDy, 
	TwoDxAccumulatedError, TwoDyAccumulatedError;

Dx = (X2-X1); 						// Berechnen die horizontale Komponente
Dy = (Y2-Y1); 						// Berechnen der vertikalen Komponente

TwoDx = Dx + Dx; 					// Die horizontale Komponente der Doppel-
TwoDy = Dy + Dy; 					// zweimal die vertikale Komponente

CurrentX = X1; 						// ab X1
CurrentY = Y1; 						// und Y1

Xinc = 1; 							// setzen wir einen Schritt Anhebung horizontalen Position
Yinc = 1; 							// setzen wir einen Schritt zur Erhhung der vertikalen Position

if(Dx < 0) 							// wenn die horizontale Komponente negativ ist 
  {
  Xinc = -1; 						// Dies wird "verschoben" werden (negative Schritt)
  Dx = -Dx;  						// Unter den Zeichen des positiven Komponente
  TwoDx = -TwoDx; 					// sowie zweimal die Komponente der
  }

if (Dy < 0) 						// wenn die vertikale Komponente negativ ist
  {
  Yinc = -1; 						// Dies wird "verschoben" werden (negative Schritt)
  Dy = -Dy; 						// Unter den Charakter Bestandteil der Zusatzstoffe
  TwoDy = -TwoDy; 					// sowie zweimal die Komponente der
  }

GLCD_SetPixel(X1,Y1, color); 		// setzen wir den ersten Schritt (Licht der ersten Pixel)

if ((Dx != 0) || (Dy != 0)) 		// berprfen, ob die Linie aus mehr als einem Punkt besteht;)
  {
  // berprfen, ob die Komponente der senkrechten weniger als oder gleich die horizontale Komponente ist
  if (Dy <= Dx) 					// wenn ja, let's go "nach iksach"
    { 
    TwoDxAccumulatedError = 0; 		// setzt die Variable
    do 								// Hit the Road
	  {
      CurrentX += Xinc; 			// Hinzufgen, um die aktuelle Position Schritt
      TwoDxAccumulatedError += TwoDy; // und hier fgen wir verdoppelt sozialen Komponenten vertikalen
      if(TwoDxAccumulatedError > Dx)  // TwoDxAccumulatedError wenn es grer ist als Dx
        {
        CurrentY += Yinc; 			// Erhhung bestehender Positionen in der vertikalen
        TwoDxAccumulatedError -= TwoDx; // und subtrahieren TwoDx
        }
       GLCD_SetPixel(CurrentX,CurrentY, color);// Setzen Sie den nchsten Schritt (helle Pixel)
       }while (CurrentX != X2); 	// Wir gehen so lange, und erreicht den Zielpunkt
     }
   else 							// Ansonsten gehen wir "nach igrekach"
      {
      TwoDyAccumulatedError = 0; 
      do 
	    {
        CurrentY += Yinc; 
        TwoDyAccumulatedError += TwoDx;
        if(TwoDyAccumulatedError>Dy) 
          {
          CurrentX += Xinc;
          TwoDyAccumulatedError -= TwoDy;
          }
         GLCD_SetPixel(CurrentX,CurrentY, color); 
         }while (CurrentY != Y2);
    }
  }
}
//
